import { renderless, api } from "@dftvue2-opentiny/vue-renderless/time-spinner/vue";
import { defineComponent, $prefix, directive, setup as _setup } from "@dftvue2-opentiny/vue-common";
import Scrollbar from "@dftvue2-opentiny/vue-scrollbar";
import bind from "@dftvue2-opentiny/vue-renderless/common/deps/repeat-click";
import { iconChevronDown, iconChevronUp } from "@dftvue2-opentiny/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@dftvue2-opentiny/vue-theme/time-spinner/index.css";
var $constants = {
  ANIMATIONNAME: "tiny-transition-timepicker"
};
var __vue2_script = defineComponent({
  name: $prefix + "TimeSpinner",
  emits: ["change", "select-range"],
  components: {
    TinyScrollbar: Scrollbar,
    IconChevronDown: iconChevronDown(),
    IconChevronUp: iconChevronUp()
  },
  directives: directive({
    repeatClick: {
      bind
    }
  }),
  props: {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    date: {},
    defaultValue: {},
    showSeconds: {
      type: Boolean,
      default: true
    },
    arrowControl: Boolean,
    amPmMode: {
      type: String,
      default: ""
      // 'a': am/pm; 'A': AM/PM
    },
    step: {
      type: Object,
      default: function _default2() {
        return {
          hour: 1,
          minute: 1,
          second: 1
        };
      },
      validator: function validator(_ref4) {
        var hour = _ref4.hour, minute = _ref4.minute, second = _ref4.second;
        var validateArray = [{
          value: hour,
          range: 24
        }, {
          value: minute,
          range: 60
        }, {
          value: second,
          range: 60
        }];
        return validateArray.every(function(_ref5) {
          var value = _ref5.value, range = _ref5.range;
          return value || value == 0 ? Math.floor(value) === value && value > 0 && value <= range : true;
        });
      }
    }
  },
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-time-spinner",
    class: {
      "has-seconds": _vm.showSeconds
    }
  }, [!_vm.arrowControl ? [_c("tiny-scrollbar", {
    ref: "hours",
    staticClass: "tiny-time-spinner__wrapper",
    class: [_vm.state.animationName],
    attrs: {
      "wrap-style": "max-height: inherit;",
      "view-class": "tiny-time-spinner__list",
      "noresize": "",
      "tag": "ul"
    },
    on: {
      "mouseenter": function mouseenter($event) {
        return _vm.emitSelectRange("hours");
      },
      "mousemove": function mousemove($event) {
        return _vm.adjustCurrentSpinner("hours");
      }
    }
  }, _vm._l(_vm.state.hoursList, function(_ref) {
    var disabled = _ref.disabled, hour = _ref.hour;
    return _c("li", {
      key: hour,
      staticClass: "tiny-time-spinner__item",
      class: {
        active: hour === _vm.state.hours,
        disabled
      },
      on: {
        "click": function click($event) {
          return _vm.handleClick("hours", {
            value: hour,
            disabled
          });
        }
      }
    }, [_c("span", [_vm._v(_vm._s(("0" + (_vm.amPmMode ? hour % 12 || 12 : hour)).slice(-2)) + _vm._s(_vm.amPm(hour)))])]);
  }), 0), _c("tiny-scrollbar", {
    ref: "minutes",
    staticClass: "tiny-time-spinner__wrapper",
    class: [_vm.state.animationName + "-up"],
    attrs: {
      "wrap-style": "max-height: inherit;",
      "view-class": "tiny-time-spinner__list",
      "noresize": "",
      "tag": "ul"
    },
    on: {
      "mouseenter": function mouseenter($event) {
        return _vm.emitSelectRange("minutes");
      },
      "mousemove": function mousemove($event) {
        return _vm.adjustCurrentSpinner("minutes");
      }
    }
  }, _vm._l(_vm.state.minutesList, function(_ref2) {
    var disabled = _ref2.disabled, minute = _ref2.minute;
    return _c("li", {
      key: minute,
      staticClass: "tiny-time-spinner__item",
      class: {
        active: minute === _vm.state.minutes,
        disabled: !disabled
      },
      on: {
        "click": function click($event) {
          return _vm.handleClick("minutes", {
            value: minute,
            disabled: false
          });
        }
      }
    }, [_c("span", [_vm._v(_vm._s(("0" + minute).slice(-2)))])]);
  }), 0), _c("tiny-scrollbar", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.showSeconds,
      expression: "showSeconds"
    }],
    ref: "seconds",
    staticClass: "tiny-time-spinner__wrapper",
    class: [_vm.state.animationName],
    attrs: {
      "wrap-style": "max-height: inherit;",
      "view-class": "tiny-time-spinner__list",
      "noresize": "",
      "tag": "ul"
    },
    on: {
      "mouseenter": function mouseenter($event) {
        return _vm.emitSelectRange("seconds");
      },
      "mousemove": function mousemove($event) {
        return _vm.adjustCurrentSpinner("seconds");
      }
    }
  }, _vm._l(_vm.state.secondsList, function(_ref3) {
    var second = _ref3.second;
    return _c("li", {
      key: second,
      staticClass: "tiny-time-spinner__item",
      class: {
        active: second === _vm.state.seconds
      },
      on: {
        "click": function click($event) {
          return _vm.handleClick("seconds", {
            value: second,
            disabled: false
          });
        }
      }
    }, [_c("span", [_vm._v(_vm._s(("0" + second).slice(-2)))])]);
  }), 0)] : _vm._e(), _vm.arrowControl ? [_c("div", {
    staticClass: "tiny-time-spinner__wrapper is-arrow",
    on: {
      "mouseenter": function mouseenter($event) {
        return _vm.emitSelectRange("hours");
      }
    }
  }, [_c("i", {
    directives: [{
      name: "repeat-click",
      rawName: "v-repeat-click",
      value: _vm.decrease,
      expression: "decrease"
    }],
    staticClass: "tiny-time-spinner__arrow tiny-icon-arrow-up"
  }, [_c("icon-chevron-up")], 1), _c("i", {
    directives: [{
      name: "repeat-click",
      rawName: "v-repeat-click",
      value: _vm.increase,
      expression: "increase"
    }],
    staticClass: "tiny-time-spinner__arrow tiny-icon-arrow-down"
  }, [_c("icon-chevron-down")], 1), _c("ul", {
    ref: "hours",
    staticClass: "tiny-time-spinner__list",
    class: [_vm.state.animationName]
  }, _vm._l(_vm.state.arrowHourList, function(hour, key) {
    return _c("li", {
      key,
      staticClass: "tiny-time-spinner__item",
      class: {
        active: hour === _vm.state.hours,
        disabled: _vm.state.hoursList.find(function(item) {
          return item.hour === hour;
        }) && _vm.state.hoursList.find(function(item) {
          return item.hour === hour;
        }).disabled
      }
    }, [_c("span", [_vm._v(_vm._s(hour === void 0 ? "" : ("0" + (_vm.amPmMode ? hour % 12 || 12 : hour)).slice(-2) + _vm.amPm(hour)))])]);
  }), 0)]), _c("div", {
    staticClass: "tiny-time-spinner__wrapper is-arrow",
    on: {
      "mouseenter": function mouseenter($event) {
        return _vm.emitSelectRange("minutes");
      }
    }
  }, [_c("i", {
    directives: [{
      name: "repeat-click",
      rawName: "v-repeat-click",
      value: _vm.decrease,
      expression: "decrease"
    }],
    staticClass: "tiny-time-spinner__arrow tiny-icon-arrow-up"
  }, [_c("icon-chevron-up")], 1), _c("i", {
    directives: [{
      name: "repeat-click",
      rawName: "v-repeat-click",
      value: _vm.increase,
      expression: "increase"
    }],
    staticClass: "tiny-time-spinner__arrow tiny-icon-arrow-down"
  }, [_c("icon-chevron-down")], 1), _c("ul", {
    ref: "minutes",
    staticClass: "tiny-time-spinner__list",
    class: [_vm.state.animationName + "-up"]
  }, _vm._l(_vm.state.arrowMinuteList, function(minute, key) {
    return _c("li", {
      key,
      staticClass: "tiny-time-spinner__item",
      class: {
        active: minute === _vm.state.minutes
      }
    }, [_c("span", [_vm._v(_vm._s(minute === void 0 ? "" : ("0" + minute).slice(-2)))])]);
  }), 0)]), _vm.showSeconds ? _c("div", {
    staticClass: "tiny-time-spinner__wrapper is-arrow",
    on: {
      "mouseenter": function mouseenter($event) {
        return _vm.emitSelectRange("seconds");
      }
    }
  }, [_c("i", {
    directives: [{
      name: "repeat-click",
      rawName: "v-repeat-click",
      value: _vm.decrease,
      expression: "decrease"
    }],
    staticClass: "tiny-time-spinner__arrow tiny-icon-arrow-up"
  }, [_c("icon-chevron-up")], 1), _c("i", {
    directives: [{
      name: "repeat-click",
      rawName: "v-repeat-click",
      value: _vm.increase,
      expression: "increase"
    }],
    staticClass: "tiny-time-spinner__arrow tiny-icon-arrow-down"
  }, [_c("icon-chevron-down")], 1), _c("ul", {
    ref: "seconds",
    staticClass: "tiny-time-spinner__list",
    class: [_vm.state.animationName]
  }, _vm._l(_vm.state.arrowSecondList, function(second, key) {
    return _c("li", {
      key,
      staticClass: "tiny-time-spinner__item",
      class: {
        active: second === _vm.state.seconds
      }
    }, [_c("span", [_vm._v(_vm._s(second === void 0 ? "" : ("0" + second).slice(-2)))])]);
  }), 0)]) : _vm._e()] : _vm._e()], 2);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var TimeSpinner = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
TimeSpinner.install = function(Vue) {
  Vue.component(TimeSpinner.name, TimeSpinner);
};
TimeSpinner.version = version;
export {
  TimeSpinner as default
};
